

/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */

"use strict";

ChromeUtils.defineModuleGetter(this, "Services", "resource://gre/modules/Services.jsm");
ChromeUtils.defineModuleGetter(this, "AddonManager", "resource://gre/modules/AddonManager.jsm");

this.EXPORTED_SYMBOLS = ["AppConstants"];

// Immutable for export.
this.AppConstants = Object.freeze({
  // See this wiki page for more details about channel specific build
  // defines: https://wiki.mozilla.org/Platform/Channel-specific_build_defines
  NIGHTLY_BUILD:
//@line 23 "$SRCDIR/toolkit/modules/AppConstants.jsm"
  false,
//@line 25 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  RELEASE_OR_BETA:
//@line 28 "$SRCDIR/toolkit/modules/AppConstants.jsm"
  true,
//@line 32 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  EARLY_BETA_OR_EARLIER:
//@line 37 "$SRCDIR/toolkit/modules/AppConstants.jsm"
  false,
//@line 39 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  IS_ESR:
//@line 44 "$SRCDIR/toolkit/modules/AppConstants.jsm"
  false,
//@line 46 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  ACCESSIBILITY:
//@line 49 "$SRCDIR/toolkit/modules/AppConstants.jsm"
  true,
//@line 53 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  // Official corresponds, roughly, to whether this build is performed
  // on Mozilla's continuous integration infrastructure. You should
  // disable developer-only functionality when this flag is set.
  MOZILLA_OFFICIAL:
//@line 61 "$SRCDIR/toolkit/modules/AppConstants.jsm"
  false,
//@line 63 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  MOZ_OFFICIAL_BRANDING:
//@line 68 "$SRCDIR/toolkit/modules/AppConstants.jsm"
  false,
//@line 70 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  MOZ_DEV_EDITION:
//@line 75 "$SRCDIR/toolkit/modules/AppConstants.jsm"
  false,
//@line 77 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  MOZ_SERVICES_SYNC:
//@line 82 "$SRCDIR/toolkit/modules/AppConstants.jsm"
  false,
//@line 84 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  MOZ_SERVICES_HEALTHREPORT:
//@line 87 "$SRCDIR/toolkit/modules/AppConstants.jsm"
  true,
//@line 91 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  MOZ_DATA_REPORTING:
//@line 94 "$SRCDIR/toolkit/modules/AppConstants.jsm"
  true,
//@line 98 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  MOZ_SANDBOX:
//@line 103 "$SRCDIR/toolkit/modules/AppConstants.jsm"
  false,
//@line 105 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  MOZ_TELEMETRY_REPORTING:
//@line 110 "$SRCDIR/toolkit/modules/AppConstants.jsm"
  false,
//@line 112 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  MOZ_TELEMETRY_ON_BY_DEFAULT:
//@line 117 "$SRCDIR/toolkit/modules/AppConstants.jsm"
  false,
//@line 119 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  MOZ_UPDATER:
//@line 124 "$SRCDIR/toolkit/modules/AppConstants.jsm"
  false,
//@line 126 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  MOZ_SWITCHBOARD:
//@line 131 "$SRCDIR/toolkit/modules/AppConstants.jsm"
  false,
//@line 133 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  MOZ_WEBRTC:
//@line 138 "$SRCDIR/toolkit/modules/AppConstants.jsm"
  false,
//@line 140 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  MOZ_WIDGET_GTK:
//@line 143 "$SRCDIR/toolkit/modules/AppConstants.jsm"
  true,
//@line 147 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  XP_UNIX:
//@line 150 "$SRCDIR/toolkit/modules/AppConstants.jsm"
  true,
//@line 154 "$SRCDIR/toolkit/modules/AppConstants.jsm"

// NOTE! XP_LINUX has to go after MOZ_WIDGET_ANDROID otherwise Android
// builds will be misidentified as linux.
  platform:
//@line 159 "$SRCDIR/toolkit/modules/AppConstants.jsm"
  "linux",
//@line 171 "$SRCDIR/toolkit/modules/AppConstants.jsm"

// Most of our frontend code assumes that any desktop Unix platform
// is "linux". Add the distinction for code that needs it.
  unixstyle:
//@line 180 "$SRCDIR/toolkit/modules/AppConstants.jsm"
    "netbsd",
//@line 188 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  isPlatformAndVersionAtLeast(platform, version) {
    let platformVersion = Services.sysinfo.getProperty("version");
    return platform == this.platform &&
           Services.vc.compare(platformVersion, version) >= 0;
  },

  isPlatformAndVersionAtMost(platform, version) {
    let platformVersion = Services.sysinfo.getProperty("version");
    return platform == this.platform &&
           Services.vc.compare(platformVersion, version) <= 0;
  },

  MOZ_CRASHREPORTER:
//@line 205 "$SRCDIR/toolkit/modules/AppConstants.jsm"
  false,
//@line 207 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  MOZ_NORMANDY:
//@line 212 "$SRCDIR/toolkit/modules/AppConstants.jsm"
  false,
//@line 214 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  MOZ_MAINTENANCE_SERVICE:
//@line 219 "$SRCDIR/toolkit/modules/AppConstants.jsm"
  false,
//@line 221 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  MOZ_BACKGROUNDTASKS:
//@line 224 "$SRCDIR/toolkit/modules/AppConstants.jsm"
  true,
//@line 228 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  MOZ_UPDATE_AGENT:
//@line 233 "$SRCDIR/toolkit/modules/AppConstants.jsm"
  false,
//@line 235 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  MOZ_BITS_DOWNLOAD:
//@line 240 "$SRCDIR/toolkit/modules/AppConstants.jsm"
  false,
//@line 242 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  DEBUG:
//@line 247 "$SRCDIR/toolkit/modules/AppConstants.jsm"
  false,
//@line 249 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  ASAN:
//@line 254 "$SRCDIR/toolkit/modules/AppConstants.jsm"
  false,
//@line 256 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  ASAN_REPORTER:
//@line 261 "$SRCDIR/toolkit/modules/AppConstants.jsm"
  false,
//@line 263 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  TSAN:
//@line 268 "$SRCDIR/toolkit/modules/AppConstants.jsm"
  false,
//@line 270 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  MOZ_SYSTEM_NSS:
//@line 273 "$SRCDIR/toolkit/modules/AppConstants.jsm"
  true,
//@line 277 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  MOZ_PLACES:
//@line 280 "$SRCDIR/toolkit/modules/AppConstants.jsm"
  true,
//@line 284 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  MOZ_REQUIRE_SIGNING:
//@line 289 "$SRCDIR/toolkit/modules/AppConstants.jsm"
  false,
//@line 291 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  get MOZ_UNSIGNED_SCOPES() {
    let result = 0;
//@line 300 "$SRCDIR/toolkit/modules/AppConstants.jsm"
    return result;
  },

  MOZ_ALLOW_ADDON_SIDELOAD:
//@line 307 "$SRCDIR/toolkit/modules/AppConstants.jsm"
  false,
//@line 309 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  MOZ_WEBEXT_WEBIDL_ENABLED:
//@line 314 "$SRCDIR/toolkit/modules/AppConstants.jsm"
  false,
//@line 316 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  MENUBAR_CAN_AUTOHIDE:
//@line 319 "$SRCDIR/toolkit/modules/AppConstants.jsm"
  true,
//@line 323 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  MOZ_ANDROID_HISTORY:
//@line 328 "$SRCDIR/toolkit/modules/AppConstants.jsm"
  false,
//@line 330 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  MOZ_GECKO_PROFILER:
//@line 335 "$SRCDIR/toolkit/modules/AppConstants.jsm"
  false,
//@line 337 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  DLL_PREFIX: "lib",
  DLL_SUFFIX: ".so",

  MOZ_APP_NAME: "thunderbird102",
  MOZ_APP_BASENAME: "Thunderbird",
  // N.b.: you almost certainly want brandShortName/brand-short-name:
  // MOZ_APP_DISPLAYNAME should only be used for static user-visible
  // fields (e.g., DLL properties, Mac Bundle name, or similar).
  MOZ_APP_DISPLAYNAME_DO_NOT_USE: "Thunderbird Daily",
  MOZ_APP_VERSION: "102.15.1",
  MOZ_APP_VERSION_DISPLAY: "102.15.1",
  MOZ_BUILDID: "20240627100945",
  MOZ_BUILD_APP: "comm/mail",
  MOZ_MACBUNDLE_ID: "org.mozilla.thunderbird-daily",
  MOZ_MACBUNDLE_NAME: "Thunderbird Daily.app",
  MOZ_UPDATE_CHANNEL: "default",
  MOZ_WIDGET_TOOLKIT: "gtk",
  ANDROID_PACKAGE_NAME: "org.mozilla.thunderbird102",

  DEBUG_JS_MODULES: "",

  MOZ_BING_API_CLIENTID: "no-bing-api-clientid",
  MOZ_BING_API_KEY: "no-bing-api-key",
  MOZ_GOOGLE_LOCATION_SERVICE_API_KEY: "no-google-location-service-api-key",
  MOZ_GOOGLE_SAFEBROWSING_API_KEY: "no-google-safebrowsing-api-key",
  MOZ_MOZILLA_API_KEY: "no-mozilla-api-key",

  BROWSER_CHROME_URL: "chrome://messenger/content/extensionPopup.xhtml",

  OMNIJAR_NAME: "omni.ja",

  // URL to the hg revision this was built from (e.g.
  // "https://hg.mozilla.org/mozilla-central/rev/6256ec9113c1")
  // On unofficial builds, this is an empty string.
//@line 375 "$SRCDIR/toolkit/modules/AppConstants.jsm"
  SOURCE_REVISION_URL: "",

  HAVE_USR_LIB64_DIR:
//@line 381 "$SRCDIR/toolkit/modules/AppConstants.jsm"
    false,
//@line 383 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  HAVE_SHELL_SERVICE:
//@line 386 "$SRCDIR/toolkit/modules/AppConstants.jsm"
    true,
//@line 390 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  MOZ_CODE_COVERAGE:
//@line 395 "$SRCDIR/toolkit/modules/AppConstants.jsm"
    false,
//@line 397 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  TELEMETRY_PING_FORMAT_VERSION: 4,

  MOZ_NEW_XULSTORE:
//@line 404 "$SRCDIR/toolkit/modules/AppConstants.jsm"
    false,
//@line 406 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  MOZ_NEW_NOTIFICATION_STORE:
//@line 411 "$SRCDIR/toolkit/modules/AppConstants.jsm"
    false,
//@line 413 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  ENABLE_WEBDRIVER:
//@line 416 "$SRCDIR/toolkit/modules/AppConstants.jsm"
    true,
//@line 420 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  REMOTE_SETTINGS_SERVER_URL:
//@line 423 "$SRCDIR/toolkit/modules/AppConstants.jsm"
    "https://thunderbird-settings.thunderbird.net/v1",
//@line 427 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  REMOTE_SETTINGS_VERIFY_SIGNATURE:
//@line 430 "$SRCDIR/toolkit/modules/AppConstants.jsm"
    false,
//@line 434 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  REMOTE_SETTINGS_DEFAULT_BUCKET:
//@line 437 "$SRCDIR/toolkit/modules/AppConstants.jsm"
    "thunderbird",
//@line 441 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  MOZ_GLEAN_ANDROID:
//@line 446 "$SRCDIR/toolkit/modules/AppConstants.jsm"
    false,
//@line 448 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  MOZ_JXL:
//@line 453 "$SRCDIR/toolkit/modules/AppConstants.jsm"
    false,
//@line 455 "$SRCDIR/toolkit/modules/AppConstants.jsm"

  // Returns true for CN region build when distibution id set as 'MozillaOnline'
  isChinaRepack() {
    return (
      Services.prefs
      .getDefaultBranch("")
      .getCharPref("distribution.id", "default") === "MozillaOnline"
    );
  },
});
